import type { JsonSchema, JsonSchema7, UISchemaElement } from "@jsonforms/core";
export type AdditionalPropertyType = {
    propertyName: string;
    path: string;
    schema?: JsonSchema;
    uischema?: UISchemaElement;
};
export declare const createAdditionProperties: (schema: JsonSchema, data: any, path?: string) => AdditionalPropertyType[];
export declare const getAdditionalKeys: (data: any, schema: JsonSchema) => string[];
export declare const getReservedPropertyNames: (properties: Record<any, any>) => string[];
/**
 *
 * "patternProperties": {
 *     "^S_": { "type": "string" },
 *     "^I_": { "type": "integer" }
 *   }
 */
export declare const getPropSchemaByPattern: (propName: string, patternProperties: Record<string, any>) => JsonSchema | undefined;
export declare const getPropSchema: (propName: string, propValue: any, schema?: JsonSchema) => JsonSchema | undefined;
export declare const getPropUiSchema: (propName: string, propSchema: JsonSchema, path?: string) => UISchemaElement | undefined;
export declare const createAdditionalProperty: (propName: string, propValue: any, schema?: JsonSchema, path?: string) => AdditionalPropertyType;
/**
 * TODO: create issue against jsonforms to add propertyNames into the JsonSchema interface
 * propertyNames exist in draft-6 but not defined in the JsonSchema
 */
export declare const getPropertyNames: (schema: JsonSchema | any) => JsonSchema7 | undefined;
export declare const createPropertyNameSchema: (schema: JsonSchema | any) => JsonSchema7 | undefined;
export declare const setNewData: (newData: Record<string, any>, additionalPropertyItems: AdditionalPropertyType[]) => boolean;
export declare const isAdditionalPropertyExists: (additionalProperty: AdditionalPropertyType, schema: JsonSchema, data: any) => boolean;
/**
 * {type: "string"} //default
 * {type: ["string","boolean"]} //as array
 * {oneOf: [{type: "string"}, {type: "boolean"}] } //as oneOf
 */
export declare const createAdvancedDefaultValue: (schema: JsonSchema) => {};
