import { type ComputedRef } from 'vue';
import type { JsonSchema, UISchemaElement } from '@jsonforms/core';
import type Ajv from 'ajv';
import { Styles } from "@jsonforms/vue-vanilla";
export interface NestedInfo {
    level: number;
    parentElement?: 'array' | 'object';
}
export declare const useComputedLabel: <I extends {
    control: any;
}>(input: I, appliedOptions: ComputedRef<any>) => ComputedRef<string>;
export declare const reuseAjvForSchema: (ajv: Ajv, schema: JsonSchema) => Ajv;
export declare const useControlAppliedOptions: <I extends {
    control: any;
}>(input: I) => ComputedRef<any>;
export declare const useNested: (element: false | 'array' | 'object') => NestedInfo;
export declare const useAjv: () => Ajv;
export declare const useTranslator: () => ComputedRef<import("@jsonforms/core").Translator>;
export declare const i18nDefaultMessages: {
    arraylayout: {
        add: string;
        delete: string;
        moveUp: string;
        moveDown: string;
        dialogTitle: string;
        dialogText: string;
        dialogConfirm: string;
        dialogCancel: string;
    };
};
/**
 * Adds styles, appliedOptions and childUiSchema
 */
export declare const useBoPlusArrayControl: <I extends {
    control: any;
}>(input: I) => I & {
    styles: Styles;
    appliedOptions: ComputedRef<any>;
    childLabelForIndex: (index: number | null) => string;
    computedLabel: ComputedRef<string>;
};
export declare const childLabelForIndexWithInput: (input: any, index: number | null) => string;
export declare const useStyles: (element?: UISchemaElement, moreStyles?: Styles) => Styles;
export declare const defaultStyles: BopStyles | any;
export interface BopStyles extends Styles {
    categorization: {
        root?: string;
        category?: string;
        selected?: string;
        panel?: string;
    };
    oneOf: {
        root?: string;
        select?: string;
    };
    allOf: {
        root?: string;
    };
    anyOf: {
        root?: string;
        category?: string;
        selected?: string;
        panel?: string;
    };
    objectAddProps: {
        root?: string;
        toolbar?: string;
        items?: string;
    };
    enumArray: {
        root?: string;
        item?: string;
        label?: string;
    };
    toggle: {
        root?: string;
        slider?: string;
    };
}
